# Parsec Cloud (https://parsec.cloud) Copyright (c) BUSL-1.1 2016-present Scille SAS

# /!\ Autogenerated by misc/gen_protocol_typings.py, any modification will be lost !

from __future__ import annotations

from parsec._parsec import (
    CancelledGreetingAttemptReason,
    DateTime,
    GreeterOrClaimer,
    GreetingAttemptID,
    HashDigest,
    PublicKey,
)

class GreeterStep:
    pass

class GreeterStepNumber0WaitPeer(GreeterStep):
    def __init__(self, public_key: PublicKey) -> None: ...
    @property
    def public_key(self) -> PublicKey: ...

class GreeterStepNumber1GetHashedNonce(GreeterStep):
    def __init__(
        self,
    ) -> None: ...

class GreeterStepNumber2SendNonce(GreeterStep):
    def __init__(self, greeter_nonce: bytes) -> None: ...
    @property
    def greeter_nonce(self) -> bytes: ...

class GreeterStepNumber3GetNonce(GreeterStep):
    def __init__(
        self,
    ) -> None: ...

class GreeterStepNumber4WaitPeerTrust(GreeterStep):
    def __init__(
        self,
    ) -> None: ...

class GreeterStepNumber5SignifyTrust(GreeterStep):
    def __init__(
        self,
    ) -> None: ...

class GreeterStepNumber6GetPayload(GreeterStep):
    def __init__(
        self,
    ) -> None: ...

class GreeterStepNumber7SendPayload(GreeterStep):
    def __init__(self, greeter_payload: bytes) -> None: ...
    @property
    def greeter_payload(self) -> bytes: ...

class GreeterStepNumber8WaitPeerAcknowledgment(GreeterStep):
    def __init__(
        self,
    ) -> None: ...

class ClaimerStep:
    pass

class ClaimerStepNumber0WaitPeer(ClaimerStep):
    def __init__(self, public_key: PublicKey) -> None: ...
    @property
    def public_key(self) -> PublicKey: ...

class ClaimerStepNumber1SendHashedNonce(ClaimerStep):
    def __init__(self, hashed_nonce: HashDigest) -> None: ...
    @property
    def hashed_nonce(self) -> HashDigest: ...

class ClaimerStepNumber2GetNonce(ClaimerStep):
    def __init__(
        self,
    ) -> None: ...

class ClaimerStepNumber3SendNonce(ClaimerStep):
    def __init__(self, claimer_nonce: bytes) -> None: ...
    @property
    def claimer_nonce(self) -> bytes: ...

class ClaimerStepNumber4SignifyTrust(ClaimerStep):
    def __init__(
        self,
    ) -> None: ...

class ClaimerStepNumber5WaitPeerTrust(ClaimerStep):
    def __init__(
        self,
    ) -> None: ...

class ClaimerStepNumber6SendPayload(ClaimerStep):
    def __init__(self, claimer_payload: bytes) -> None: ...
    @property
    def claimer_payload(self) -> bytes: ...

class ClaimerStepNumber7GetPayload(ClaimerStep):
    def __init__(
        self,
    ) -> None: ...

class ClaimerStepNumber8Acknowledge(ClaimerStep):
    def __init__(
        self,
    ) -> None: ...

class Req:
    def __init__(self, greeting_attempt: GreetingAttemptID, claimer_step: ClaimerStep) -> None: ...
    def dump(self) -> bytes: ...
    @property
    def claimer_step(self) -> ClaimerStep: ...
    @property
    def greeting_attempt(self) -> GreetingAttemptID: ...

class Rep:
    @staticmethod
    def load(raw: bytes) -> Rep: ...
    def dump(self) -> bytes: ...

class RepUnknownStatus(Rep):
    def __init__(self, status: str, reason: str | None) -> None: ...
    @property
    def status(self) -> str: ...
    @property
    def reason(self) -> str | None: ...

class RepOk(Rep):
    def __init__(self, greeter_step: GreeterStep) -> None: ...
    @property
    def greeter_step(self) -> GreeterStep: ...

class RepNotReady(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepGreeterRevoked(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepGreeterNotAllowed(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepGreetingAttemptNotFound(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepGreetingAttemptNotJoined(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepGreetingAttemptCancelled(Rep):
    def __init__(
        self, origin: GreeterOrClaimer, timestamp: DateTime, reason: CancelledGreetingAttemptReason
    ) -> None: ...
    @property
    def origin(self) -> GreeterOrClaimer: ...
    @property
    def reason(self) -> CancelledGreetingAttemptReason: ...
    @property
    def timestamp(self) -> DateTime: ...

class RepStepTooAdvanced(Rep):
    def __init__(
        self,
    ) -> None: ...

class RepStepMismatch(Rep):
    def __init__(
        self,
    ) -> None: ...
